﻿
Partial Class Results
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        'Code to handle shopper number #######
        Dim ErrorFlag As Integer
        Dim CurrentTime As String
        Dim SessionShopperNum As String
        ShopperErrorLabel.Visible = False
        ErrorFlag = 0
        CurrentTime = System.DateTime.Now.Ticks.ToString

        Try
            SessionShopperNum = Session("ShopperNum")
            If (SessionShopperNum Is Nothing) OrElse (SessionShopperNum = "0") Then
                Using carEntities As New CarEntities()
                    Dim S As New CarShopper With {.ShopperLastName = CurrentTime, _
                    .ShopperFirstName = "", .ShopperStreet = "", .ShopperCity = "", .ShopperZipCode = "", _
                    .ShopperState = "", .ShopperPhone = "", .ShopperEmail = ""}   ' temporary name for now
                    carEntities.CarShoppers.Add(S)
                    carEntities.SaveChanges()

                    'One technique for finding the ID of the inserted item.  For another way, see AddToCart
                    'click handler below when it inserts a new basket.
                    Dim Match = From CarShopper In carEntities.CarShoppers
                       Select CarShopper Where (CarShopper.ShopperLastName = CurrentTime)
                    Session("ShopperNum") = Match.FirstOrDefault.ID
                End Using
            End If
        Catch exception As Exception
            ErrorFlag = 1
        End Try

        If ErrorFlag = 1 Then
            ShopperErrorLabel.Visible = True
        End If
        'End of code to handle shopper number #######

        Dim Brand As String
        Dim Model As String

        ErrorLabel.Visible = False
        If Session.Count > 0 Then
            Try
                'Brand = ____________ ' get this from the saved value in Session state
                'Model = ____________ ' get this from the saved value in Session state
                BrandLabel.Text = "Brand: " & Brand
                BrandLabel.Visible = True
                ModelLabel.Text = "Model: " & Model
                ModelLabel.Visible = True
                Using carEntities As New CarEntities()
                    'Dim query = From Car In carEntities.CarCategoryProducts
                    '            Where Car.CarCategory.BrandName = Brand And Car.CarProduct.ModelName = ________
                    '            Select Car
                    Dim Match = query.FirstOrDefault().CarProduct
                    CarDescriptionBox.Text = Match.Description
                    CarDescriptionBox.Visible = True
                    Session.Add("Description", Match.Description)
                    PriceLabel.Text = "Price:  " & String.Format("{0:C}", Match.Price)
                    PriceLabel.Visible = True
                    Session.Add("Price", Match.Price)
                    Session.Add("ProdNum", Match.ID)   ' record the ID of the car product
                End Using
            Catch exception As Exception
                ErrorLabel.Visible = True
            End Try
        Else   ' No Session data was supplied
            ErrorLabel.Visible = True
        End If
    End Sub

    Protected Sub AddToCartButton_Click(sender As Object, e As EventArgs) Handles AddToCartButton.Click
        Try
            Session.Add("Quantity", CType(QuantityDropDownList.SelectedItem.Value, Integer))
            If Session("BasketNum") Is Nothing Then   ' need to make a new basket.  Note the check for Nothing.
                Using carEntities As New CarEntities()
                    Dim B As New CarBasket With {.ShopperNum = CInt(Session("ShopperNum"))}
                    carEntities.CarBaskets.Add(B)
                    carEntities.SaveChanges()
                    Session("BasketNum") = B.BasketNum  ' One way to get the ID of the newly inserted item.
                End Using
            End If
            ' Now we have a basket, whether new or old.

            Dim ProdNum As Integer = CInt(Session("ProdNum"))
            Dim BasketNum As Integer = CInt(Session("BasketNum"))
            Dim NumCars As Integer = CInt(Session("Quantity"))
            Dim UnitPrice As Decimal = CDec(Session("Price"))
            Dim BItemTotal As Decimal = NumCars * UnitPrice

            Using carEntities As New CarEntities()
                'Dim query = From CarBasketItem In carEntities.CarBasketItems _
                '    Where (CarBasketItem.ProdNum = ProdNum) And (CarBasketItem.BasketNum = ____________) _
                '    Select CarBasketItem

                If (query.Count() = 0) Then   ' We simply insert the new basket item.
                    Dim BItem As New CarBasketItem With {.BasketNum = BasketNum, .ProdNum = ProdNum, _
                         .BasketItemPrice = UnitPrice, .BasketItemProdName = Session("ModelSelected"), _
                         .BasketItemQuantity = NumCars, .BasketItemTotal = BItemTotal}
                    carEntities.CarBasketItems.Add(BItem)
                    carEntities.SaveChanges()
                Else   ' We need to update the existing basket item record for this car (by adding to its quantity field).
                    ' *** You might want to ask the user if the user really intends to add more of the same to the cart.
                    Dim Match = query.FirstOrDefault
                    Match.BasketItemQuantity = Match.BasketItemQuantity + NumCars
                    Match.BasketItemTotal = Match.BasketItemTotal + _______________
                    carEntities.SaveChanges()
                End If
            End Using
        Catch exception As Exception
            ErrorLabel.Visible = True
        End Try

        If ErrorLabel.Visible = False Then
            Response.Redirect("Cart.aspx")
        End If
    End Sub
End Class
